routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\DepartmentController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


Route::resource('employees', EmployeeController::class);

Route::get('employees/{employee}/confirm-delete', 'App\Http\Controllers\EmployeeController@confirmDelete')->name('employees.confirm-delete');

Route::resource('departments', DepartmentController::class);

Route::get('/dashboard', 'App\Http\Controllers\DashboardController@index')->name('dashboard');

app/Models/Employee.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Employee extends Model
{
    use HasFactory, SoftDeletes;

    protected $fillable = ['name', 'department_id'];

    public function department()
    {
        return $this->belongsTo(Department::class);
    }

    public function contacts()
    {
        return $this->hasMany(Contact::class);
    }

    public function addresses()
    {
        return $this->hasMany('App\Models\Address','employee_id');
    }
}

app/Http/Controllers/EmployeeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Department;
use App\Models\Employee;
use App\Models\Address;
use App\Models\Contact;
use Illuminate\Http\Request;

class EmployeeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $search = $request->input('search');
        $employees = Employee::where('name', 'like', '%' . $search . '%')->get();

        return view('employees.index', compact('employees', 'search'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $departments = Department::all();
        return view('employees.create', compact('departments'));    
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'department_id' => 'required|exists:departments,id',
        ]);

        $employee = new Employee;
        $employee->name = $request->input('name');
        $employee->department_id = $request->input('department_id');
        $employee->save();

        if ($request->has('contact_numbers')) {
            foreach ($request->input('contact_numbers') as $number) {
                $employee->contacts()->create(['phone' => $number]);
            }
        }

        if ($request->has('addresses')) {
            foreach ($request->input('addresses') as $address) {
                $employee->addresses()->create(['address' => $address]);
            }
        }

        return redirect()->route('employees.index')->with('success', 'Employee added successfully.');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $employee = Employee::findOrFail($id);
        $employeeAddresses = Address::where('employee_id', $id)->get();

        return view('employees.show', compact('employee', 'employeeAddresses'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $employee = Employee::with(['contacts'])->findOrFail($id);
        $employeeAddresses = Address::where('employee_id', $id)->get();        
        $departments = Department::all();

        return view('employees.edit', compact('employee','employeeAddresses','departments'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $employee = Employee::findOrFail($id);

        $employee->update([
            'name' => $request->input('name'),
            'department_id' => $request->input('department_id'),
        ]);

        $contactNumbers = $request->input('contact_numbers', []);
        $employee->contacts()->delete();
        foreach ($contactNumbers as $number) {
            $employee->contacts()->create(['phone' => $number]);
        }

        $addresses = $request->input('addresses', []);
        $employee->addresses()->delete();
        foreach ($addresses as $address) {
            $employee->addresses()->create(['address' => $address]);
        }

        return redirect()->route('employees.index')->with('success', 'Employee updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $employee = Employee::findOrFail($id);
        $employee->delete();

        $contact = Contact::where('employee_id', $id);
        $contact->delete();

        $contact = Address::where('employee_id', $id);
        $contact->delete();

        return redirect()->route('employees.index')->with('success', 'Employee deleted successfully.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function confirmDelete($id)
    {
        $employee = Employee::findOrFail($id);
        return view('employees.confirm-delete', compact('employee'));
    }
}

resources/views/employees/confirm-delete.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h1>Confirm Deletion</h1>
        <p>Are you sure you want to delete this employee?</p>
        <p><strong>Name:</strong> {{ $employee->name }}</p>
        <p><strong>Department:</strong> {{ $employee->department->name }}</p>

        <form action="{{ route('employees.destroy', $employee->id) }}" method="POST">
            @csrf
            @method('DELETE')
            <div class="mb-3">
                <button type="submit" class="btn btn-danger">Delete</button>
                <a href="{{ route('employees.index') }}" class="btn btn-secondary">Cancel</a>
            </div>
        </form>
    </div>
@endsection

resources/views/employees/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h1>Add Employee</h1>

        <form action="{{ route('employees.store') }}" method="POST">
            @csrf
            
            <div class="mb-3">
                <label for="name" class="form-label">Name:</label>
                <input type="text" name="name" class="form-control" required>
            </div>

            <div class="mb-3">
                <label for="department_id" class="form-label">Department:</label>
                <select name="department_id" class="form-select">
                    @foreach ($departments as $department)
                        <option value="{{ $department->id }}">{{ $department->name }}</option>
                    @endforeach
                </select>
            </div>

            <div class="mb-3">
                <label for="contact_numbers" class="form-label">Contact Numbers:</label>
                <div class="input-group">
                    <input type="text" name="contact_numbers[]" class="form-control" placeholder="Contact Number">
                    <div class="input-group-append" style="margin-left: 10px;">
                        <button type="button" class="btn btn-success" id="add-contact">Add</button>
                    </div>
                </div>
                <div id="contact-numbers-container"></div>
            </div>

            <div class="mb-3">
                <label for="addresses" class="form-label">Addresses:</label>
                <div class="input-group">
                    <input type="text" name="addresses[]" class="form-control" placeholder="Address">
                    <div class="input-group-append" style="margin-left: 10px;">
                        <button type="button" class="btn btn-success" id="add-address">Add</button>
                    </div>
                </div>
                <div id="addresses-container"></div>
            </div>            

            <div class="mb-3">
                <button type="submit" class="btn btn-primary">Add Employee</button>
                <a href="{{ route('employees.index') }}" class="btn btn-secondary">Back to List</a>
            </div>
        </form>
    </div>
@endsection

<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>

<script>
    $(document).ready(function () {
        $('#add-contact').click(function () {
            $('#contact-numbers-container').append('<div class="input-group mt-2"><input type="text" name="contact_numbers[]" class="form-control" placeholder="Contact Number"><button type="button" class="btn btn-danger remove-contact">Remove</button></div>');
        });

        $('#add-address').click(function () {
            $('#addresses-container').append('<div class="input-group mt-2"><input type="text" name="addresses[]" class="form-control" placeholder="Address"><button type="button" class="btn btn-danger remove-address">Remove</button></div>');
        });

        $('#contact-numbers-container').on('click', '.remove-contact', function () {
            $(this).parent().remove();
        });

        $('#addresses-container').on('click', '.remove-address', function () {
            $(this).parent().remove();
        });
    });
</script>

resources/views/employees/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h1>Edit Employee</h1>

        <form action="{{ route('employees.update', $employee->id) }}" method="POST">
            @csrf
            @method('PUT')

            <div class="mb-3">
                <label for="name" class="form-label">Name:</label>
                <input type="text" name="name" class="form-control" value="{{ $employee->name }}" required>
            </div>

            <div class="mb-3">
                <label for="department_id" class="form-label">Department:</label>
                <select name="department_id" class="form-select">
                    @foreach ($departments as $department)
                        <option value="{{ $department->id }}" {{ $employee->department_id == $department->id ? 'selected' : '' }}>
                            {{ $department->name }}
                        </option>
                    @endforeach
                </select>
            </div>

            <p><strong>Contact Numbers:</strong></p>
            @foreach ($employee->contacts as $key => $contactNumber)
                <div class="mb-3">
                    <label for="contact_numbers[{{ $key }}]" class="form-label">Contact Number {{ $key + 1 }}:</label>
                    <input type="text" name="contact_numbers[{{ $key }}]" class="form-control" value="{{ $contactNumber->phone }}">
                </div>
            @endforeach

            <p><strong>Addresses:</strong></p>
            @foreach ($employeeAddresses as $key => $address)
                <div class="mb-3">
                    <label for="addresses[{{ $key }}]" class="form-label">Address {{ $key + 1 }}:</label>
                    <input type="text" name="addresses[{{ $key }}]" class="form-control" value="{{ $address->address }}">
                </div>
            @endforeach

            <div class="mb-3">
                <button type="submit" class="btn btn-primary">Update Employee</button>
                <a href="{{ route('employees.index') }}" class="btn btn-secondary">Back to List</a>
            </div>
        </form>
    </div>
@endsection

resources/views/employees/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h1>Employee List</h1>
        <div class="mb-3">
            <a href="{{ route('employees.create') }}" class="btn btn-primary">Add Employee</a>
        </div>

        <form action="{{ route('employees.index') }}" method="GET" class="mb-3">
            <div class="input-group">
                <input type="text" name="search" class="form-control" placeholder="Search by Name" value="{{ $search }}">                
                <button type="submit" class="btn btn-primary">Search</button>
            </div>
        </form>

        <table class="table table-bordered">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Department</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                @forelse ($employees as $employee)
                    <tr>
                        <td>{{ $employee->name }}</td>
                        <td>{{ $employee->department->name }}</td>
                        <td>
                            <a href="{{ route('employees.show', $employee->id) }}" class="btn btn-info">View</a>
                            <a href="{{ route('employees.edit', $employee->id) }}" class="btn btn-warning">Edit</a>
                            <a href="{{ route('employees.confirm-delete', $employee->id) }}" class="btn btn-danger">Delete</a>
                        </td>
                    </tr>
                @empty
                    <tr>
                        <td colspan="3">No employees found.</td>
                    </tr>
                @endforelse
            </tbody>
        </table>
    </div>
@endsection

resources/views/employees/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h1>Employee Details</h1>
        <p><strong>Name:</strong> {{ $employee->name }}</p>
        <p><strong>Department:</strong> {{ $employee->department->name }}</p>
        <p><strong>Contact Numbers:</strong></p>
        <ul>            
            @foreach ($employee->contacts ?? [] as $contactNumber)
                <li>{{ $contactNumber->phone }}</li>
            @endforeach
        </ul>

        <p><strong>Addresses:</strong></p>
        <ul>            
            @foreach ($employeeAddresses ?? [] as $address)
                <li>{{ $address->address }}</li>
            @endforeach
        </ul>

        <div class="mb-3">
            <a href="{{ route('employees.index') }}" class="btn btn-secondary">Back to List</a>
        </div>
    </div>
@endsection